<template>
    <ul class="basic-pagination">
        <!-- start prev page -->
        <li v-if="currentPage === 1" class="disabled">
            <a href="javascript:void(0)">
                <ChevronLeftIcon />
            </a>
        </li>
        <li v-else>
            <a @click="onClickPage(currentPage - 1)" href="javascript:void(0)">
                <ChevronLeftIcon />
            </a>
        </li>
        <!-- end prev page -->

        <!-- start first page -->
        <li v-if="currentPage === 1" class="active disabled">
            <a href="javascript:void(0);">1</a>
        </li>
        <li v-else>
            <a @click="onClickPage(1)" href="javascript:void(0);">1</a>
        </li>
        <!-- end first page -->

        <!-- pages -->
        <template v-if="currentPage > 4 && currentPage < lastPage - 3">
            <li class="disabled">
                <a href="javascript:void(0);">…</a>
            </li>
            <li>
                <a
                    @click="onClickPage(currentPage - 1)"
                    href="javascript:void(0);"
                >
                    {{ currentPage - 1 }}
                </a>
            </li>
            <li class="active disabled">
                <a href="javascript:void(0);">{{ currentPage }}</a>
            </li>
            <li>
                <a
                    @click="onClickPage(currentPage + 1)"
                    href="javascript:void(0);"
                >
                    {{ currentPage + 1 }}
                </a>
            </li>
            <li class="disabled">
                <a href="javascript:void(0);">…</a>
            </li>
        </template>
        <template v-else>
            <template v-if="lastPage <= 5">
                <li
                    :key="page"
                    v-for="page in arrPageLess5"
                    :class="{ 'active disabled': currentPage === page }"
                >
                    <a v-if="currentPage === page" href="javascript:void(0);">
                        {{ page }}
                    </a>
                    <a
                        v-else
                        @click="onClickPage(page)"
                        href="javascript:void(0);"
                    >
                        {{ page }}
                    </a>
                </li>
            </template>
            <template v-else>
                <template v-if="currentPage <= 4">
                    <li
                        :key="page"
                        v-for="page in arrPageBetween1"
                        :class="{ 'active disabled': currentPage === page }"
                    >
                        <a
                            v-if="currentPage === page"
                            href="javascript:void(0);"
                        >
                            {{ page }}
                        </a>
                        <a
                            v-else
                            @click="onClickPage(page)"
                            href="javascript:void(0);"
                        >
                            {{ page }}
                        </a>
                    </li>
                    <li v-if="lastPage !== 6" class="disabled">
                        <a href="javascript:void(0);">…</a>
                    </li>
                </template>
                <template v-else-if="currentPage > lastPage - 4">
                    <li v-if="lastPage !== 6" class="disabled">
                        <a href="javascript:void(0);">…</a>
                    </li>
                    <li
                        :key="page"
                        v-for="page in arrPageBetween2"
                        :class="{ 'active disabled': currentPage === page }"
                    >
                        <a
                            v-if="currentPage === page"
                            href="javascript:void(0);"
                        >
                            {{ page }}
                        </a>
                        <a
                            v-else
                            @click="onClickPage(page)"
                            href="javascript:void(0);"
                        >
                            {{ page }}
                        </a>
                    </li>
                </template>
            </template>
        </template>
        <!-- end pages -->

        <!-- start last page -->
        <template v-if="lastPage > 1">
            <li v-if="currentPage === lastPage" class="active disabled">
                <a href="javascript:void(0);">{{ lastPage }}</a>
            </li>
            <li v-else>
                <a @click="onClickPage(lastPage)" href="javascript:void(0);">
                    {{ lastPage }}
                </a>
            </li>
        </template>
        <!-- end last page -->

        <!-- start next page -->
        <li v-if="currentPage === lastPage" class="disabled">
            <a href="javascript:void(0)">
                <ChevronRightIcon />
            </a>
        </li>
        <li v-else>
            <a @click="onClickPage(currentPage + 1)" href="javascript:void(0)">
                <ChevronRightIcon />
            </a>
        </li>
        <!-- end next page -->
    </ul>
</template>

<script>
import { ref } from "vue";
import { ChevronLeftIcon, ChevronRightIcon } from "@heroicons/vue/outline";

export default {
    components: {
        ChevronLeftIcon,
        ChevronRightIcon
    },
    props: {
        currentPage: {
            type: Number,
            required: true,
            default: 1
        },
        lastPage: {
            type: Number,
            required: true,
            default: 1
        }
    },
    setup(props, context) {
        const arrPageLess5 = ref([]);
        const arrPageBetween1 = ref([]);
        const arrPageBetween2 = ref([]);

        let arrPage1 = [];
        for (let i = 2; i <= props.lastPage - 1; i++) {
            arrPage1.push(i);
        }
        arrPageLess5.value = arrPage1;

        let arrPage2 = [];
        for (let i = 2; i <= 5; i++) {
            arrPage2.push(i);
        }
        arrPageBetween1.value = arrPage2;

        let arrPage3 = [];
        for (let i = props.lastPage - 4; i < props.lastPage; i++) {
            arrPage3.push(i);
        }
        arrPageBetween2.value = arrPage3;

        function onClickPage(page) {
            context.emit("onClickPage", page);
        }

        return { arrPageLess5, arrPageBetween1, arrPageBetween2, onClickPage };
    }
};
</script>

<style lang="scss" scoped>
ul {
    display: inline-flex;
    li {
        width: 35px;
        height: 35px;
        line-height: 35px;
        &:first-child a {
            border-top-left-radius: 1.428rem;
            border-bottom-left-radius: 1.428rem;
        }
        &:last-child a {
            border-top-right-radius: 1.428rem;
            border-bottom-right-radius: 1.428rem;
        }
        &:first-child a svg,
        &:last-child a svg,
        &:first-child svg,
        &:last-child svg {
            color: #b9b9c3 !important;
            margin: auto;
            height: inherit;
        }
        a {
            display: inline-block;
            text-align: center;
            width: inherit;
            height: inherit;
            line-height: inherit;
            color: #6e6b7b;
            background-color: #f3f2f7;
            &:hover,
            &:hover svg {
                color: #7367f0 !important;
                text-decoration: underline;
            }
        }
        &.disabled a,
        &.disabled a svg {
            color: #b9b9c3 !important;
            cursor: default;
            &:hover {
                text-decoration: unset;
            }
        }
        &.active {
            background-color: #f3f2f7;
            a {
                font-weight: bold;
                color: #ffffff !important;
                background-color: #7367f0;
                border-radius: 50%;
            }
        }
    }
}
</style>
